require 'test/unit'
require 'external/test_support'
IWATestSupport.set_src_dir
require 'rbconfig'
require 'net/http'
begin
	require 'mongrel'
	HAS_MONGREL = true
rescue LoadError
	HAS_MONGREL = false
end

if HAS_MONGREL

	class TC_Mongrel < Test::Unit::TestCase

		@@testdir = IWATestSupport.test_dir(__FILE__)
		def setup
			Dir.chdir(@@testdir)
			IWATestSupport.announce(:cgiadaptor,"Mongrel/IOWA Integration")
			ruby = File.join(::Config::CONFIG['bindir'],::Config::CONFIG['ruby_install_name'])
			ruby << ::Config::CONFIG['EXEEXT']
	
			assert_nothing_raised("setup failed") do
				@iowa_pid = IWATestSupport::create_process(:dir => 'TC_Mongrel/iowa',
					:cmd => [ruby,'-I../../../src','app.rb'])
				sleep 1
			end
		end

		def teardown
			Process.kill 'SIGKILL',@iowa_pid
			sleep 1
		end
	
		def get_url(hostname,port,url)
			Net::HTTP.start(hostname,port) {|http| http.get(url)}
		end

		def testBasicGet
		end

		def testFollowLink
			end
		end
	end

end
